Save object schema
curl --request PUT \
--url https://api.roofkit.ai/api/v1/objects/{object_id}/schema \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--header 'Idempotency-Key: <idempotency-key>' \
--data '
{
"label_plural": "<string>",
"label_singular": "<string>",
"icon": "<string>",
"color": "<string>",
"fields": [
{}
],
"description": "<string>",
"highlight_field_ids": [
"<string>"
],
"archived_field_ids": [
"<string>"
],
"attribute_order": [
"<string>"
]
}
'import requests
url = "https://api.roofkit.ai/api/v1/objects/{object_id}/schema"
payload = {
"label_plural": "<string>",
"label_singular": "<string>",
"icon": "<string>",
"color": "<string>",
"fields": [{}],
"description": "<string>",
"highlight_field_ids": ["<string>"],
"archived_field_ids": ["<string>"],
"attribute_order": ["<string>"]
}
headers = {
"Idempotency-Key": "<idempotency-key>",
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.put(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'PUT',
headers: {
'Idempotency-Key': '<idempotency-key>',
Authorization: 'Bearer <token>',
'Content-Type': 'application/json'
},
body: JSON.stringify({
label_plural: '<string>',
label_singular: '<string>',
icon: '<string>',
color: '<string>',
fields: [{}],
description: '<string>',
highlight_field_ids: ['<string>'],
archived_field_ids: ['<string>'],
attribute_order: ['<string>']
})
};
fetch('https://api.roofkit.ai/api/v1/objects/{object_id}/schema', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.roofkit.ai/api/v1/objects/{object_id}/schema",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "PUT",
CURLOPT_POSTFIELDS => json_encode([
'label_plural' => '<string>',
'label_singular' => '<string>',
'icon' => '<string>',
'color' => '<string>',
'fields' => [
[
]
],
'description' => '<string>',
'highlight_field_ids' => [
'<string>'
],
'archived_field_ids' => [
'<string>'
],
'attribute_order' => [
'<string>'
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json",
"Idempotency-Key: <idempotency-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.roofkit.ai/api/v1/objects/{object_id}/schema"
payload := strings.NewReader("{\n \"label_plural\": \"<string>\",\n \"label_singular\": \"<string>\",\n \"icon\": \"<string>\",\n \"color\": \"<string>\",\n \"fields\": [\n {}\n ],\n \"description\": \"<string>\",\n \"highlight_field_ids\": [\n \"<string>\"\n ],\n \"archived_field_ids\": [\n \"<string>\"\n ],\n \"attribute_order\": [\n \"<string>\"\n ]\n}")
req, _ := http.NewRequest("PUT", url, payload)
req.Header.Add("Idempotency-Key", "<idempotency-key>")
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.put("https://api.roofkit.ai/api/v1/objects/{object_id}/schema")
.header("Idempotency-Key", "<idempotency-key>")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"label_plural\": \"<string>\",\n \"label_singular\": \"<string>\",\n \"icon\": \"<string>\",\n \"color\": \"<string>\",\n \"fields\": [\n {}\n ],\n \"description\": \"<string>\",\n \"highlight_field_ids\": [\n \"<string>\"\n ],\n \"archived_field_ids\": [\n \"<string>\"\n ],\n \"attribute_order\": [\n \"<string>\"\n ]\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.roofkit.ai/api/v1/objects/{object_id}/schema")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Put.new(url)
request["Idempotency-Key"] = '<idempotency-key>'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"label_plural\": \"<string>\",\n \"label_singular\": \"<string>\",\n \"icon\": \"<string>\",\n \"color\": \"<string>\",\n \"fields\": [\n {}\n ],\n \"description\": \"<string>\",\n \"highlight_field_ids\": [\n \"<string>\"\n ],\n \"archived_field_ids\": [\n \"<string>\"\n ],\n \"attribute_order\": [\n \"<string>\"\n ]\n}"
response = http.request(request)
puts response.read_body{
"saved": true,
"object_id": "<string>",
"slug": "<string>"
}{
"error": {
"code": "UNAUTHORIZED",
"message": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"code": "UNAUTHORIZED",
"message": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"code": "FORBIDDEN",
"message": "API key does not include the required scope: leads.write.",
"request_id": "req_123",
"details": {
"required_scope": "leads.write",
"missing_scopes": [
"leads.write"
]
}
}
}{
"error": {
"code": "UNAUTHORIZED",
"message": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"code": "UNAUTHORIZED",
"message": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"code": "UNAUTHORIZED",
"message": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"code": "UNAUTHORIZED",
"message": "<string>",
"request_id": "<string>",
"details": {}
}
}Data Objects
Save object schema
Saves field drafts, archived fields, and attribute order for a custom object. Omitted record values are not this contract. Contacts status options can update through this path.
PUT
/
api
/
v1
/
objects
/
{object_id}
/
schema
Save object schema
curl --request PUT \
--url https://api.roofkit.ai/api/v1/objects/{object_id}/schema \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--header 'Idempotency-Key: <idempotency-key>' \
--data '
{
"label_plural": "<string>",
"label_singular": "<string>",
"icon": "<string>",
"color": "<string>",
"fields": [
{}
],
"description": "<string>",
"highlight_field_ids": [
"<string>"
],
"archived_field_ids": [
"<string>"
],
"attribute_order": [
"<string>"
]
}
'import requests
url = "https://api.roofkit.ai/api/v1/objects/{object_id}/schema"
payload = {
"label_plural": "<string>",
"label_singular": "<string>",
"icon": "<string>",
"color": "<string>",
"fields": [{}],
"description": "<string>",
"highlight_field_ids": ["<string>"],
"archived_field_ids": ["<string>"],
"attribute_order": ["<string>"]
}
headers = {
"Idempotency-Key": "<idempotency-key>",
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.put(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'PUT',
headers: {
'Idempotency-Key': '<idempotency-key>',
Authorization: 'Bearer <token>',
'Content-Type': 'application/json'
},
body: JSON.stringify({
label_plural: '<string>',
label_singular: '<string>',
icon: '<string>',
color: '<string>',
fields: [{}],
description: '<string>',
highlight_field_ids: ['<string>'],
archived_field_ids: ['<string>'],
attribute_order: ['<string>']
})
};
fetch('https://api.roofkit.ai/api/v1/objects/{object_id}/schema', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.roofkit.ai/api/v1/objects/{object_id}/schema",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "PUT",
CURLOPT_POSTFIELDS => json_encode([
'label_plural' => '<string>',
'label_singular' => '<string>',
'icon' => '<string>',
'color' => '<string>',
'fields' => [
[
]
],
'description' => '<string>',
'highlight_field_ids' => [
'<string>'
],
'archived_field_ids' => [
'<string>'
],
'attribute_order' => [
'<string>'
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json",
"Idempotency-Key: <idempotency-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.roofkit.ai/api/v1/objects/{object_id}/schema"
payload := strings.NewReader("{\n \"label_plural\": \"<string>\",\n \"label_singular\": \"<string>\",\n \"icon\": \"<string>\",\n \"color\": \"<string>\",\n \"fields\": [\n {}\n ],\n \"description\": \"<string>\",\n \"highlight_field_ids\": [\n \"<string>\"\n ],\n \"archived_field_ids\": [\n \"<string>\"\n ],\n \"attribute_order\": [\n \"<string>\"\n ]\n}")
req, _ := http.NewRequest("PUT", url, payload)
req.Header.Add("Idempotency-Key", "<idempotency-key>")
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.put("https://api.roofkit.ai/api/v1/objects/{object_id}/schema")
.header("Idempotency-Key", "<idempotency-key>")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"label_plural\": \"<string>\",\n \"label_singular\": \"<string>\",\n \"icon\": \"<string>\",\n \"color\": \"<string>\",\n \"fields\": [\n {}\n ],\n \"description\": \"<string>\",\n \"highlight_field_ids\": [\n \"<string>\"\n ],\n \"archived_field_ids\": [\n \"<string>\"\n ],\n \"attribute_order\": [\n \"<string>\"\n ]\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.roofkit.ai/api/v1/objects/{object_id}/schema")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Put.new(url)
request["Idempotency-Key"] = '<idempotency-key>'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"label_plural\": \"<string>\",\n \"label_singular\": \"<string>\",\n \"icon\": \"<string>\",\n \"color\": \"<string>\",\n \"fields\": [\n {}\n ],\n \"description\": \"<string>\",\n \"highlight_field_ids\": [\n \"<string>\"\n ],\n \"archived_field_ids\": [\n \"<string>\"\n ],\n \"attribute_order\": [\n \"<string>\"\n ]\n}"
response = http.request(request)
puts response.read_body{
"saved": true,
"object_id": "<string>",
"slug": "<string>"
}{
"error": {
"code": "UNAUTHORIZED",
"message": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"code": "UNAUTHORIZED",
"message": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"code": "FORBIDDEN",
"message": "API key does not include the required scope: leads.write.",
"request_id": "req_123",
"details": {
"required_scope": "leads.write",
"missing_scopes": [
"leads.write"
]
}
}
}{
"error": {
"code": "UNAUTHORIZED",
"message": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"code": "UNAUTHORIZED",
"message": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"code": "UNAUTHORIZED",
"message": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"code": "UNAUTHORIZED",
"message": "<string>",
"request_id": "<string>",
"details": {}
}
}Required scopes:
data_objects.schema.manageAuthorizations
Use Authorization: Bearer rk_live_....
Headers
A unique value for each new request, such as a UUID. Send the same value to retry a request safely. The same key and payload replay the first response with Idempotency-Replayed: true.
Required string length:
1 - 160Path Parameters
Object id, system key such as system:leads, or slug from discovery.
Required string length:
1 - 200Body
application/json